#include "sgl.h"

Uint8 bm_pixel_get(int x, int y);
void bm_pixel_set(int x, int y, Uint8 v);
void bm_pixel_set2(int x,int y, Uint8 col);
Uint8 bm_pixel_get2(int x,int y);
void bm_pixel_set3(int x,int y, Uint8 col);
Uint8 bm_pixel_get3(int x,int y);
Uint8 bm_pixel_get_scroll(Uint8 scroll, int x, int y);
void bm_pixel_set_scroll(Uint8 scroll, int x, int y,Uint8 v);
void bm_rect_f(Uint8 bitmap,int x,int y, int dx, int dy, int col);
 

#define         NBG0_CEL_ADR    (VDP2_VRAM_A0   )
#define         NBG0_COL_ADR    (VDP2_COLRAM    )
#define         NBG1_CEL_ADR    (VDP2_VRAM_B0   )
#define         NBG1_COL_ADR    (VDP2_COLRAM    )

#define         RBG_CEL_ADR     (VDP2_VRAM_B1   )
#define         RBG_COL_ADR     (VDP2_COLRAM    )

#define	S2D_PAL	        pal_vf
#define	S2D_PALSIZE	1024L
#define X_MAX 352
#define Y_MAX 240


#define PAL_PLAYER   1
#define PAL_WATER    (PLAYER_NUM+PAL_PLAYER+1)
#define PAL_WATER_S  20
#define PAL_SAND     (PAL_WATER+PAL_WATER_S)
#define PAL_SAND_S   7
#define PAL_T        (PAL_SAND+PAL_SAND_S)
#define PAL_T_S      90
#define PAL_FUMEE    (PAL_T+PAL_T_S)
#define PAL_FUMEE_S  40

typedef struct {
  Uint16 c1;
  Uint16 c2;
  Uint16 c3;
  Uint16 c4;
  Uint16 c5;

} TANK_COLOR;

void bitmap_init();

void cal_pal();
void rotate_pal();
int in_type(int a,int beg, int size);
void fire_zone(int x, int y, int dx, int dy);
int terrain_check_borders(FIXED pos[XY]);
int terrain_check_type(FIXED from[XY],FIXED to[XY]);
void test_palette();
void copy_portions();
void clear_one();
void ground_destroy(int x,int y);

int text_write_char(Uint8 scroll,int x,int y,int num,int scale,int col);
int text_write(Uint8 scroll,int x,int y,char * string,int scale,int col);
int text_write_int(Uint8 scroll,int x, int y, int num, int scale,int col);


typedef struct {
  int x;
  int y;
  int prof;
  Uint32 size;
} INTERPOINT;



void terrain_init();
