#include "bomb.h"
#include "player.h"
#include "random.h"
#include "bitmap.h"
#include "coll.h"
#include "sound.h"
#include "trigolo.h"

extern SPR_ATTR attr[];
extern PDATA PD_PLANE3;
extern PLAYER Players[];
extern ATTR attribute_PLANE3[];
extern Uint16	pal_vf[];
extern TANK_COLOR tank_cols[];

BOMB Bombs[MAX_BOMB];


void bombs_init(){
  int i;
  for (i=0;i<MAX_BOMB;i++){
    Bombs[i].st = BS_NOOP;
  }
}

int bomb_fire(int to,FIXED src[XY],FIXED dest[XY],int col){
  int fired=0;
  int i=0;
  do {

    if (Bombs[i].st == BS_NOOP){
      //      if (terrain_check_borders(dest)){
      Bombs[i].to   = to;
      Bombs[i].i_to = Bombs[i].to;
      Bombs[i].src[X] = src[X];
      Bombs[i].src[Y] = src[Y];
      Bombs[i].dest[X] = dest[X];
      Bombs[i].dest[Y] = dest[Y];
      Bombs[i].col = col;
      Bombs[i].st = BS_LAUNCHED;
      Bombs[i].hit = -1;
      fired=1;
      sound_tell(vs_b_fire,1);
      //      }
    }
    i++;
  } while ((i<MAX_BOMB)&&(!fired));
  return fired;
}


#define TRAJ_SIN_TABLE_S 40

FIXED Traj_sin_table[TRAJ_SIN_TABLE_S];

void init_traj_sin_table(){
  int i;
  for (i=0;i<TRAJ_SIN_TABLE_S;i++){
    ANGLE cura = DEGtoANG(180.0*(1.0*i)/(1.0*TRAJ_SIN_TABLE_S));
    Traj_sin_table[i] = slSin(cura);
  }
}

void bomb_display_traj(FIXED* src,FIXED* dest,int to,int i_to,int col){

  float step = (1.0*(i_to-to))/(1.0*i_to);
  
  FIXED pos[XY];

  pos[X] = src[X] + slMulFX((dest[X]-src[X]),toFIXED(step));
  pos[Y] = src[Y] + slMulFX((dest[Y]-src[Y]),toFIXED(step));
  

  FIXED superscale = Traj_sin_table[TRAJ_SIN_TABLE_S*to/i_to];

  static FIXED post[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(1.0)};
  post[X] = pos[X];
  post[Y] = pos[Y];
  post[3] = slMulFX(toFIXED(0.5),superscale);
  slDispSprite(post, (SPR_ATTR *)(&attr[33].texno), 0x0);   

  int v = PAL_FUMEE+(PAL_FUMEE_S-1)/2+minmaxrndint(0,(PAL_FUMEE_S-1)/2);
  int add;

  if (step<0.5){
    add = (int) (8*step);
  } else {
    add = 4 - (int) ((step-0.5)*8);
  }
  add = minmaxrndint(add/2,add);
  bm_pixel_set2((pos[X]>>16)+add,pos[Y]>>16,v);
  bm_pixel_set2((pos[X]>>16)-add,pos[Y]>>16,v);
  bm_pixel_set2(pos[X]>>16,(pos[Y]>>16)+add,v);
  bm_pixel_set2(pos[X]>>16,(pos[Y]>>16)-add,v);

}

void bomb_display_fragments(int posx,int posy,int to,int hit){
  //  to -> EXPL_TO


  int i;
  for (i=0;i<4;i++){
    int x = posx - 6 + minmaxrndint(0,12);
    int y = posy - 6 + minmaxrndint(0,12);
    Uint8 col;
    if (hit==-1){
      col = PAL_FUMEE+(PAL_FUMEE_S-1)/2 + minmaxrndint(0,(PAL_FUMEE_S-1)/2);
    } else {
      col =  PAL_FUMEE+(PAL_FUMEE_S-1)/2 + minmaxrndint(0,(PAL_FUMEE_S-1)/2);
    }
    bm_pixel_set2(x,y,col);
  }

  if (hit!=-1){
    attribute_PLANE3[0].colno = tank_cols[hit].c1;
  } else {    
    Uint8 col = bm_pixel_get(posx,posy);
    attribute_PLANE3[0].colno = pal_vf[col];
  }

  static FIXED Z = toFIXED(176.0);
  int superscale = 3.0+15.0*to/(BS_EXPL_TO);

  static ANGLE ax = 0;
  static ANGLE az = 0;
  ax += DEGtoANG(49.0);
  //  az += slRandom()>>14;
  /*
  slPushMatrix(); 
  {
    slTranslate(toFIXED(posx*1.0),toFIXED(posy*1.0),Z);
    slPushMatrix();
    {
      slPushMatrix();
      {
	slRotZ(ax);
	//	slRotX(ax);
	slScale(toFIXED(2.0*superscale),toFIXED(2.0*superscale),toFIXED(1.0));
	slPutPolygon(&PD_PLANE3);
      }
      slPopMatrix();
    }
    slPopMatrix();
  }
  slPopMatrix();
  */
}


void bombs_display(){

  int i;
  for (i=0;i<MAX_BOMB;i++){

    if (Bombs[i].st == BS_LAUNCHED){
      bomb_display_traj(Bombs[i].src,Bombs[i].dest,Bombs[i].to,Bombs[i].i_to,Bombs[i].col);
    }

    if (Bombs[i].st == BS_EXPL_D){
    }

    if (Bombs[i].st == BS_EXPL){
      int exp_size = 20*(BS_EXPL_TO-Bombs[i].to)/BS_EXPL_TO;
      int pos[XY];
      int fois ;
      for (fois=0;fois<1;fois++){
	
	ANGLE ang = DEGtoANG(minmaxrndint(0,360)*1.0);
	FIXED ray = minmaxrnd(toFIXED(0.0),toFIXED(1.0*exp_size));

	FIXED coscos = sinus(ang);
	FIXED sinsin = cosinus(ang);
	pos[X] = (Bombs[i].dest[X]+slMulFX(coscos,ray))>>16;
	pos[Y] = (Bombs[i].dest[Y]-slMulFX(sinsin,ray))>>16;

	bomb_display_fragments(pos[X],pos[Y],Bombs[i].to,Bombs[i].hit);
	ground_destroy(pos[X],pos[Y]);
      }
    }
  }   
}

void bombs_step(){
  int i;
  for (i=0;i<MAX_BOMB;i++){
    if (Bombs[i].st != BS_NOOP){
      Bombs[i].to--;
    }
    if (Bombs[i].to <= 0){
      if (Bombs[i].st == BS_LAUNCHED){
	Bombs[i].st = BS_EXPL_D;
	Bombs[i].to =  BS_EXPL_D_TO;
      } else if (Bombs[i].st == BS_EXPL_D){
	Bombs[i].st = BS_EXPL;
	Bombs[i].to =  BS_EXPL_TO;
      } else if (Bombs[i].st == BS_EXPL){
	Bombs[i].st = BS_NOOP;
      }
    }
  }
}



void bomb_bloodify(FIXED pi[XY],FIXED pb[XY]){
  int i;

  int xi = pi[X]>>16;
  int yi = pi[Y]>>16;
  int xb = pb[X]>>16;
  int yb = pb[Y]>>16;

  int xmax = xi + 5*(xi-xb);
  int ymax = yi + 5*(yi-yb);

  for (i=0;i<20;i++){
    int xx = minmaxrndint(xi,xmax);
    int yy = minmaxrndint(yi,ymax);
    bm_pixel_set(xx,yy,1);
  }
}
void bombs_check_players(){
  int i,j;
  for (i=0;i<MAX_BOMB;i++){
    int bombcoll = 0;
    for (j=0;j<PLAYER_NUM;j++){
      if ((Players[j].plays) && (Players[j].energy>0)){

	if (Bombs[i].st == BS_EXPL_D ){
	    if (Bombs[i].to == BS_EXPL_D_TO){
	      

	      FIXED lp[XY];
	      lp[X]=toFIXED(TANK_SIZE*1.0);
	      lp[Y]=toFIXED(TANK_SIZE*0.7);

	      FIXED lb[XY];
	      lb[X]=toFIXED(4.0);
	      lb[Y]=toFIXED(4.0);

	      int coll = rect_collide(Players[j].pos,Players[j].dir,lp,Bombs[i].dest,0x0,lb);
	      
	      if (coll){
		bombcoll = 1;
		sound_tell(vs_b_tank,2);
		Players[j].hurt = 30;
		Players[j].energy -= 100;
		Players[j].hurt_by = Bombs[i].col;
		Bombs[i].hit = j;
	      } else {

		if (Players[j].is_infant){
		  if (!(Players[j].infant.dead)){
		    lp[X]=toFIXED(4.0);
		    lp[Y]=toFIXED(4.0);
		    
		    int coll = rect_collide(Players[j].infant.pos,Players[j].infant.ang,lp,Bombs[i].dest,0x0,lb);
		    
		    if (coll){
		      bombcoll = 1;
		      sound_tell(vs_b_tank,2);
		      Players[j].infant.dead = 1;
		      Bombs[i].hit = j;
		      bomb_bloodify(Players[j].infant.pos,Bombs[i].dest);
		    }
		  }
		}
	      }

	    } 
	}
	  
	
	if (Bombs[i].st == BS_EXPL ){
	  if (circle_collide(Bombs[i].dest,Players[j].pos,toFIXED(1.0*BOMB_RADIUS))){
	    /*
	      Players[j].hurt = 4;
	      Players[j].energy -= 5;
	      Players[j].hurt_by  = Bombs[i].col;
	    */
	  }
	}
      }
    }

    if (Bombs[i].st == BS_EXPL_D ){
      if (Bombs[i].to == BS_EXPL_D_TO){
	if (!bombcoll){
	  Uint16 col = bm_pixel_get(Bombs[i].dest[X]>>16,Bombs[i].dest[Y]>>16);
	  if (in_type(col,PAL_WATER,PAL_WATER_S)){
	    sound_tell(vs_b_eau,2);
	  } else {
	    sound_tell(vs_b_terre,2);
	  }
	}
      }
    }
  }
}
