#include    "sgl.h"
#include    "sound.h"
#include    "bomb.h"
#include    "bitmap.h"
#include    "player.h"
#include    "random.h"
#include    "pad.h"
#include    "bonus.h"
#include    "coll.h"
#include    "mitrail.h"
#include    "trigolo.h"
#include    "bup/bup.h"
extern PLAYER Players[];
extern int p_pad[];

#define MAX_VICTORY 100

/*
 * SPRITES
 */ 
#define SPRITE_NB          35

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern SPR_ATTR attr[];

static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
  TEXTURE *txptr;

  for(; NbPicture-- > 0; pcptr++){
    txptr = tex_spr + pcptr->texno;
    slDMACopy((void *)pcptr->pcsrc,
	      (void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
	      (Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
  }
}

// pixel

#define TX 0.5
#define TY 0.5

POINT point_PLANE1[]= {
  POStoFIXED(-TX,-TY,0.0),
  POStoFIXED( TX,-TY,0.0),
  POStoFIXED( TX, TY,0.0),
  POStoFIXED(-TX, TY,0.0),
};

POLYGON polygon_PLANE1[]= {
  NORMAL(0.0,1.0,0.0),
  VERTICES(0,1,2,3),
};

#define pppp Dual_Plane
//#define pppp Single_Plane
/*
  ATTR attribute_PLANE1[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(31,0,0),No_Gouraud,MESHon|CL_Trans,sprPolygon,No_Option),  
  };
  ATTR attribute_PLANE2[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(0,31,0),No_Gouraud,MESHon|CL_Trans,sprPolygon,No_Option),  
  };
  ATTR attribute_PLANE3[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(0,0,31),No_Gouraud,MESHon|CL_Trans,sprPolygon,No_Option),  
  };
*/
ATTR attribute_PLANE1[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(31,0,0),No_Gouraud,MESHoff,sprPolygon,No_Option),  
};
ATTR attribute_PLANE2[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(0,31,0),No_Gouraud,MESHoff,sprPolygon,No_Option),  
};
ATTR attribute_PLANE3[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(0,0,31),No_Gouraud,MESHoff,sprPolygon,No_Option),  
};
ATTR attribute_TARGET[]= {
  ATTRIBUTE(pppp,SORT_CEN,No_Texture,C_RGB(0,0,31),No_Gouraud,MESHoff|CL_Trans,sprPolygon,No_Option),  
};

PDATA PD_PLANE1 = {
  point_PLANE1,sizeof(point_PLANE1)/sizeof(POINT),
  polygon_PLANE1,sizeof(polygon_PLANE1)/sizeof(POLYGON),
  attribute_PLANE1
};
PDATA PD_PLANE2 = {
  point_PLANE1,sizeof(point_PLANE1)/sizeof(POINT),
  polygon_PLANE1,sizeof(polygon_PLANE1)/sizeof(POLYGON),
  attribute_PLANE2
};
PDATA PD_PLANE3 = {
  point_PLANE1,sizeof(point_PLANE1)/sizeof(POINT),
  polygon_PLANE1,sizeof(polygon_PLANE1)/sizeof(POLYGON),
  attribute_PLANE3
};
PDATA PD_TARGET = {
  point_PLANE1,sizeof(point_PLANE1)/sizeof(POINT),
  polygon_PLANE1,sizeof(polygon_PLANE1)/sizeof(POLYGON),
  attribute_TARGET
};



void gfx_init(){

  //  slInitSystem(TV_320x240, NULL, 1);
  //   slInitSystem(TV_640x480, NULL, 1);
  slInitSystem(TV_352x240,tex_spr, 1);
  slTVOff();
  slColRAMMode(CRM16_2048);

  // palette
  cal_pal();
  bitmap_init();
  set_sprite(pic_spr, SPRITE_NB);

  slTVOn();

}


int check_game_over(){
  int i;
  int alive=0;
  for (i=0;i<PLAYER_NUM;i++){
    if (Players[i].plays)
      alive += (Players[i].energy>0)?1:0;
    if (alive == 2)
      break;
  }
  return (alive<2);
}


void instructions_write1(){

  int col = PAL_PLAYER;
  int col2 = PAL_PLAYER+1;
  int col3 = PAL_PLAYER+2;

  int xpos = -X_MAX/2+30;
  int xpos2 = xpos+90;

  int ypos = -Y_MAX/2+30;

  text_write(bmNBG0,xpos,ypos,"CHARETTE A BESTIAUX",2,col); ypos+=25;
  text_write(bmNBG0,xpos,ypos,"IS A SIMPLE TANK GAME FEATURING UP TO 12",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"TANKS    IT IS NOT MEANT TO BE PLAYED ALONE",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"ALTHOUGH IT IS POSSIBLE    IT IS EVEN POSSIBLE",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"NOT TO PLAY AT ALL AND TO LET THE CPU",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"CONTROLED CIPIUS TAKE CARE OF THE WHOLE",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"DESTRUCTION",1,col2);ypos+=8;
  ypos+=7;

  text_write(bmNBG0,xpos,ypos,"ALL YOU HAVE TO DO TO WIN A GAME IS TO BE",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"THE LAST ONE ALIVE",1,col2);ypos+=8;

  ypos+=7;
  text_write(bmNBG0,xpos,ypos,"YOU CAN MOVE YOUR TANK WITH DIRECTIONS",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"KEYS AND FIRE WITH YOUR OTHER HAND",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"THE TURRET CAN AIM AT ANY DIRECTIONS",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"AND AFFECTS THE CANNON SHOOT BUT NOT",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"THE SMOOTHBORE SHOOT",1,col2);ypos+=8;
  ypos+=10;

  text_write(bmNBG0,xpos,ypos,"SMOOTHBORE IS A GOOD WORD I LIKE BUT I",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"LIKE HOWITZER A LOT TOO   IN FACT IT IS",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"SOME SORT OF GUN",1,col2);ypos+=8;
  

  text_write(bmNBG0,-X_MAX/2+10,Y_MAX/2-10,"CONTINUE WITH A",1,PAL_PLAYER+2);ypos+=8;
}

void instructions_write2(){

  int col = PAL_PLAYER;
  int col2 = PAL_PLAYER+1;
  int col3 = PAL_PLAYER+2;

  int xpos = -X_MAX/2+30;
  int xpos2 = xpos+90;

  int ypos = -Y_MAX/2+30;

  text_write(bmNBG0,xpos,ypos,"MOREOVER",2,col); ypos+=25;

  ypos+=10;
  text_write(bmNBG0,xpos,ypos,"YOU MAY NOTICE SOME MOVING THINGS ON",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"THE GROUND    THERE ARE TWO KINDS OF",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"THESE THINGS   THE LITTLE ONE IS GOOD",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"FOR YOUR ENERGY  THE OTHER NOT",1,col2);ypos+=8;

  ypos+=10;
  text_write(bmNBG0,xpos,ypos,"YOU CAN STEP OUT OF THE TANK AND",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"BECOME A SQUARE SOLDIER  DONT GET CRUSHED",1,col2);ypos+=8;


  ypos+=10;
  text_write(bmNBG0,xpos,ypos,"WHEN YOUR TANK IS HIT YOU LOSE ENERGY ",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"AT SOME LEVEL YOU CANNOT MOVE   THEN YOU",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"CANNOT MOVE THE TURRET   THEN YOU CANNOT",1,col2);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"SHOOT   THEN YOU DIE",1,col2);ypos+=8;

  text_write(bmNBG0,-X_MAX/2+10,Y_MAX/2-10,"CONTINUE WITH A",1,PAL_PLAYER+2);ypos+=8;

}
void instructions_write3(){

  int col = PAL_PLAYER;
  int col2 = PAL_PLAYER+1;
  int col3 = PAL_PLAYER+2;

  int xpos = -X_MAX/2+30;
  int xpos2 = xpos+90;

  int ypos = -Y_MAX/2+30;

  text_write(bmNBG0,xpos,ypos,"CONTROLS",2,col3); ypos+=8;
  text_write(bmNBG0,xpos,ypos,"",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"UP DOWN",1,col2);
  text_write(bmNBG0,xpos2,ypos,"MOVE FORWARDS BACKWARDS",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"L AND R",1,col2);
  text_write(bmNBG0,xpos2,ypos,"TURN COUNTER AND CLOCKWISE",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"X AND Y" ,1,col2);
  text_write(bmNBG0,xpos2,ypos,"TURN THE TURRET",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"START",1,col2); 
  text_write(bmNBG0,xpos2,ypos,"AUTOPILOT ON",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"A B C",1,col2); 
  text_write(bmNBG0,xpos2,ypos,"AUTODESTRUCTION",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"A PRESSED" ,1,col2);
  text_write(bmNBG0,xpos2,ypos,"SET CANNON FIRE DISTANCY AND AIM",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"A RELEASED" ,1,col2);
  text_write(bmNBG0,xpos2,ypos,"CANNON SHOOT",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"C" ,1,col2);
  text_write(bmNBG0,xpos2,ypos,"SMOOTHBORE SHOOT",1,col);ypos+=8;

  ypos+=20;
  text_write(bmNBG0,xpos,ypos,"MATCH OPTIONS",2,col3); ypos+=8;
  text_write(bmNBG0,xpos,ypos,"",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"SIX PLAYERS",1,col2);
  text_write(bmNBG0,xpos2,ypos,"CAN PLAY SIMULTANEOUSLY",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"CIPIUS",1,col2);
  text_write(bmNBG0,xpos2,ypos,"ARE IA CONTROLED TANKS",1,col);ypos+=8;
  text_write(bmNBG0,xpos2,ypos,"CAN BE ADDED OR NOT TO THE GAME",1,col);ypos+=8;
  text_write(bmNBG0,xpos,ypos,"GAME LENGHT",1,col2);
  text_write(bmNBG0,xpos2,ypos,"CAN BE SET UP TO 100 SETS",1,col);ypos+=8;
  
  
  text_write(bmNBG0,-X_MAX/2+10,Y_MAX/2-10,"LET US CONTINUE WITH A",1,PAL_PLAYER+2);ypos+=8;

}


void instructions_write(){
  gfx_init();
  instructions_write1();
  do {
    slSynch();
  } while (!pad_someone_presses(PER_DGT_TA,1));
  gfx_init();
  instructions_write2();
  do {
    slSynch();
  } while (!pad_someone_presses(PER_DGT_TA,1));
  gfx_init();
  instructions_write3();
  do {
    slSynch();
  } while (!pad_someone_presses(PER_DGT_TA,1));
}

void shake(){
  slScrPosNbg1(minmaxrnd(toFIXED(-1.0),toFIXED(1.0)),(minmaxrnd(toFIXED(0.0),toFIXED(1.0))));
}

void artifice(FIXED d[XY], int scale, int srcx, int srcy, int destx, int desty, int to){

  FIXED source[XY];
  FIXED destination[XY];

  source[X] = toFIXED(1.0*srcx*scale)+d[X];
  source[Y] = toFIXED(1.0*srcy*scale)+d[Y];
  destination[X] = toFIXED(1.0*destx*scale)+d[X];
  destination[Y] = toFIXED(1.0*desty*scale)+d[Y];
  bomb_fire(to,source,destination,1);
}

extern Uint16 pal_vf[];

void pseudo_rotate_limit(int f, int size){

  int col = pal_vf[f];
  int i;
  for (i=f;i<(f+size-1);i++){
    pal_vf[i] =  pal_vf[i+1];
  }
  pal_vf[f+size-1] =  col;

  
}
void present_rotate_pal(){
  pseudo_rotate_limit(PAL_WATER,255-PAL_WATER);

  pseudo_rotate_limit(PAL_FUMEE + (PAL_FUMEE_S/2),PAL_FUMEE_S/2-1);
  pseudo_rotate_limit(PAL_T,PAL_T_S-1);

  slDMACopy((void*)S2D_PAL, (void*)NBG1_COL_ADR, (Uint32)S2D_PALSIZE);
}

#define MAX_SHOT 30

int a[][4]={
  {0,3,2,2},{2,2,0,1},{0,1,1,0}, //S
  {2,3,3,2},{3,2,2,1},{2,1,3,0}, //S
  {4,3,4,0} ,{4,0,5,1} ,{5,1,6,0} ,{6,0,6,3} , // M
  {7,0,9,0} ,{8,3,8,0} , // T
  {10,0,12,0},{11,1,10,1},{10,3,10,0}}; //F

// returns 1 for instructions

int present(BANDELETTES* bandelettes){

  int help = 0;
  bombs_init();
  players_init();
  //  slBMBoxFill(-X_MAX/2,X_MAX/2,-Y_MAX/2,Y_MAX/2,0);
  

  FIXED off[XY];
  off[X] = toFIXED(-130.0);
  off[Y] = toFIXED(-90.0);

  int to = 35;  
  int scale =20;

  int let_to=0;
  int title_to = 0;
  FIXED sp[PLAYER_NUM][XY];

  int i;
  for (i=0;i<PLAYER_NUM;i++){
    sp[i][X] = toFIXED(-2.0)+minmaxrnd(toFIXED(0.0),toFIXED(4.0));
    sp[i][Y] = toFIXED(-3.0)+minmaxrnd(toFIXED(0.0),toFIXED(6.0));
    Players[i].pos[X] = toFIXED(0.0);//toFIXED(-X_MAX/2+minmaxrndint(0,X_MAX));
    Players[i].pos[Y] = toFIXED(0.0);//toFIXED(-Y_MAX/2+minmaxrndint(0,Y_MAX));
  }

  do {
 
    present_rotate_pal();


    if ((let_to--)==0){
      let_to = minmaxrndint(0,10);
      int p = minmaxrndint(0,14);
      if (let_to&0x1){
	artifice(off,scale,a[p][0],a[p][1],a[p][2],a[p][3],to);
      } else {
	artifice(off,scale,a[p][2],a[p][3],a[p][0],a[p][1],to);
      }
    }

    title_to++;
    switch (title_to){
      /*    case 1 : text_write_int(bmNBG1,60,10,bandelettes->version,1,PAL_PLAYER);break;
      //  case 1 : text_write_int(bmNBG1,60,10,bandelettes->n_on,1,PAL_PLAYER);break;
      case 2 : text_write_int(bmNBG1,60,20,bandelettes->n_games,1,PAL_PLAYER);break;
      case 3 : text_write_int(bmNBG1,60,30,bandelettes->game_n_round,1,PAL_PLAYER);break;
      case 4 : text_write_int(bmNBG1,60,40,bandelettes->game_add_cipius,1,PAL_PLAYER);break;
      */
    case 50 :  
      text_write(bmNBG1,-160,10,"CHARETTE",3,-1); 
      sound_tell(vs_m_tank,3);
      break;
    case 80 :  
      text_write(bmNBG1,40,10,"A",3,-1); 
      sound_tell(vs_m_tank,3);
      break;
    case 100 :  
      text_write(bmNBG1,-160,30,"BESTIAUX ",5,-1);
      sound_tell(vs_m_tank,3);
      break;
    case (130) : {
      int x = text_write_int(bmNBG1,60,100,bandelettes->n_on,1,PAL_PLAYER);
      if (bandelettes->n_on>1){
	text_write(bmNBG1,x,100," BATTLES",1,PAL_PLAYER); 
      } else {
	text_write(bmNBG1,x,100," BATTLE",1,PAL_PLAYER); 
      }
      break;
    }
    case 140 : {
      int x = -X_MAX/2+20;
      text_write(bmNBG1,x,100,"PRESS B TO GET HELP",1,PAL_PLAYER+1); 
      text_write(bmNBG1,x,110,"PRESS A TO BEGIN",1,PAL_PLAYER+1); 
    }
      break;
      
    }

    for (i=0;i<20;i++)
      clear_one();

    for (i=0;i<PLAYER_NUM;i++){
      
      Players[i].pos[X] += sp[i][X];
      Players[i].pos[Y] += sp[i][Y];
      
      sp[i][Y]+=toFIXED(0.1);
      
      if (Players[i].pos[X]>toFIXED(X_MAX*0.5)) {sp[i][X] = -sp[i][X];Players[i].pos[X]=toFIXED(X_MAX*0.5-1);}
      if (Players[i].pos[X]<toFIXED(-X_MAX*0.5)) {sp[i][X] = -sp[i][X];Players[i].pos[X]=toFIXED(-X_MAX*0.5+1);}
      if (Players[i].pos[Y]>toFIXED(Y_MAX*0.5)) {
	sp[i][Y] = -sp[i][Y];Players[i].pos[Y]=toFIXED(Y_MAX*0.5);	    
	sound_tell(vs_m_tank,3);
      }

      if (Players[i].pos[Y]<toFIXED(-Y_MAX*0.5)) {
	sp[i][Y] = toFIXED(0.0);Players[i].pos[Y]=toFIXED(-Y_MAX*0.5);
	sound_tell(vs_m_tire,3);
      }    


      Players[i].dir += DEGtoANG(1.0);
      player_display(&(Players[i]),2,0);
    }

 
    bombs_display();
    bombs_step();

    if (pad_someone_presses(PER_DGT_TB,1)){
      help = 1;
    }
    sound_step();
    slSynch();
  } while (!(
	     (pad_someone_presses(PER_DGT_TA,0))
	     ||(pad_someone_presses(PER_DGT_ST,0))
	     ||help));
  slSynch();

  return help;
}

typedef struct {
  int pad[PLAYER_NUM];
  int n_round;
  int add_cipius;
} GAME;

void game_init(GAME* g, BANDELETTES* b){
  int i;
  for (i=0;i<PLAYER_NUM;i++){
    g->pad[i] = -1;
  }  
  g->n_round = b->game_n_round;
  g->add_cipius = b->game_add_cipius;
}

int g_first_unused_player(GAME* g){
  int i;
  int pl_num = -1;


  for (i=0;i<PLAYER_NUM;i++){
    if ((g->pad[i])==-1){
      pl_num = i;
      break;
    }
  } 
  
  return pl_num;
}

int g_pad_in_use(GAME *g, int pad_num){
  int i;

  for (i=0;i<PLAYER_NUM;i++){
    if ((g->pad[i])==pad_num){
      return i;
    }
  }
  return -1;
}

int g_get_n_human_player(GAME* g){
  int z;
  int total_player = 0;
  for (z=0;z<PLAYER_NUM;z++){
    total_player += (g->pad[z] != -1)?1:0;
  }
  return total_player;
}

void game_selection(GAME* g,BANDELETTES* b){

  int xxplayer =  -X_MAX/2+20;
  int yyplayer = -Y_MAX/2+20;
  int xxcipius = xxplayer;
  int yycipius = -25;
  int xxturns  = xxplayer;
  int yyturns  = 40;

  int last_n_round = -1;
  int last_add_cipius = -1;
  
  bm_rect_f(bmNBG0,-X_MAX/2,-Y_MAX/2,X_MAX,Y_MAX,0);
  bm_rect_f(bmNBG1,-X_MAX/2,-Y_MAX/2,X_MAX,Y_MAX,0);

  game_init(g,b);

  Uint8 stop=0;

  int i;
  slSynch();

  text_write(bmNBG0,xxplayer,yyplayer,"PLAYERS",2,PAL_PLAYER);
  xxcipius = text_write(bmNBG0,xxcipius,yycipius,"CIPIUS",2,PAL_PLAYER+6);
  xxturns = text_write(bmNBG0,xxturns,yyturns,"ROUNDS",2,PAL_PLAYER+1);
  xxcipius = 0;
  xxturns = 0;


  int xpos,ypos;
  xpos =  -X_MAX/2+20;
  ypos = Y_MAX/2-30;
  xpos = text_write(bmNBG0,xpos,ypos,"PRESS A TO SELECT OR DESELECT A PLAYER",1,PAL_PLAYER+2);
  xpos = text_write(bmNBG0,xpos,ypos,"PRESS THE DI",1,PAL_PLAYER+3);
  ypos += 9;
  xpos = -X_MAX/2+20;
  xpos = text_write(bmNBG0,xpos,ypos,"RECTION KEYS TO CHANGE THE GAME LENGHT",1,PAL_PLAYER+3);
  xpos = text_write(bmNBG0,xpos,ypos,"PRESS B TO A",1,PAL_PLAYER+4);
  ypos += 9;
  xpos = -X_MAX/2+20;
  xpos = text_write(bmNBG0,xpos,ypos,"DD SOME CIPIUS",1,PAL_PLAYER+4);
  xpos = text_write(bmNBG0,xpos,ypos,"PRESS START TO START",1,PAL_PLAYER+5);

  do {

    // Player input

    for(i=0;i<MAX_PAD;i++){
      Uint16 r_pad_num = p_pad[i];
      Uint16 padp = ~(Smpc_Peripheral[r_pad_num].push);
      if (padp & PER_DGT_TA){
	int used_by = g_pad_in_use(g,r_pad_num);
	if (used_by != -1){
	  g->pad[used_by] = -1;
	} else {
	  int unused_player = g_first_unused_player(g);
	  if (unused_player != -1)
	    g->pad[unused_player] = r_pad_num;
	  //	  text_write(bmNBG1,-30,-30,"X",2,1);
	  //	  text_write_int(bmNBG1,0,-30,100+g->pad[i],3,1);
	}
      }
    }
    
    if ((pad_someone_presses(PER_DGT_KU,1))||(pad_someone_presses(PER_DGT_KR,1))){
      g->n_round += 1;
    }
    if ((pad_someone_presses(PER_DGT_KD,1))||(pad_someone_presses(PER_DGT_KL,1))){	
      g->n_round -= 1;
    }
    if (pad_someone_presses(PER_DGT_ST,1)) {
      stop = 1;
    }
    if (pad_someone_presses(PER_DGT_TB,1)) {
      g->add_cipius = !(g->add_cipius);
    }
    if ((g->n_round)<=0) g->n_round = 1;
    if ((g->n_round)>=MAX_VICTORY) g->n_round = MAX_VICTORY-1;

    // display
    for(i=0;i<PLAYER_NUM;i++){
      PLAYER* pl = &(Players[i]);
      int margin = 30;
      pl->pos[X]=toFIXED(-X_MAX/2.0)+toFIXED(margin+i*((X_MAX-(2*margin)))/PLAYER_NUM*1.0);
      if (g->pad[i] != -1){
	pl->pos[Y]=toFIXED(-Y_MAX/2.0)+toFIXED(margin+40);
	pl->dir = pl->dir/2;
	player_display(&(Players[i]),2,0);
      } else {
	if (g->add_cipius){
	  pl->pos[Y]=toFIXED(-Y_MAX/2.0)+toFIXED(margin+40+60);
	  pl->dir +=DEGtoANG(1.0);
	  player_display(&(Players[i]),1,0);
	}
      }
    }

    if (last_n_round != g->n_round){
      bm_rect_f(bmNBG1,xxturns,yyturns,100,16,0);
      text_write_int(bmNBG1,xxturns,yyturns,g->n_round,2,1);
      last_n_round = g->n_round;
    }
    if (last_add_cipius != g->add_cipius){
      bm_rect_f(bmNBG1,xxcipius,yycipius,45,16,0);
      text_write(bmNBG1,xxcipius,yycipius,(g->add_cipius)?"ON":"OFF",2,1);
      last_add_cipius = g->add_cipius;
    }

    if (stop){
      if (!(g->add_cipius)){
	stop = (g_get_n_human_player(g)>1);
      }
    }

    slSynch();
  } while (!stop);
  
}


void tes_sound_multi(){
  do {


    if (pad_someone_presses(PER_DGT_TX,1)) sound_tell(vs_b_fire,1);

    if (pad_someone_presses(PER_DGT_TA,1)) sound_tell(vs_b_terre,2);
    if (pad_someone_presses(PER_DGT_TB,1)) sound_tell(vs_b_eau,2);
    if (pad_someone_presses(PER_DGT_TC,1)) sound_tell(vs_b_tank,2);

    if (pad_someone_presses(PER_DGT_KL,1)) sound_tell(vs_m_tire,3);
    if (pad_someone_presses(PER_DGT_KR,1)) sound_tell(vs_m_tank,4);


    
    sound_step();
    slSynch();
  } while (!pad_someone_presses(PER_DGT_ST,1));
}

void printtranspal(){
  int x,y,col=0;
  for (x=-X_MAX/2;x<(X_MAX/2);x++){
    for (y=110;y<120;y++){

      bm_pixel_set2(x,y,col);
    }
    col = (col+1)%256;
  }
}

void test_table(){
  trigolo_init();
  slInitSystem(TV_352x240,tex_spr, 1);
  int i;
  int base = 0;
  for (;;){

    if (pad_someone_presses(PER_DGT_KD,0)) base++;
    if (pad_someone_presses(PER_DGT_KU,0)) base--;
    
    if (base<0) base = 0;


    for (i=0;i<30;i++){
      ANGLE ang = (DEGtoANG(1.0*(i+base)));
      slPrint("                                                                                                                                ",slLocate(0,i));
      slPrintHex(ang,slLocate(0,i));
      slPrintHex(slSin(ang),slLocate(10,i));
      slPrintHex(sinus(ang),slLocate(20,i));
      slPrintHex(slSin(ang)-sinus(ang),slLocate(30,i));
    }
    slSynch();
  }
  

}

void test_back(){

  slInitBitMap(bmRBG0, BM_512x256,(void *)RBG_CEL_ADR);
  slClearBitMap(0);
  slInitBitMap(bmNBG0, BM_512x256,(void *)NBG0_CEL_ADR);
  slClearBitMap(0);
  slInitBitMap(bmNBG1, BM_512x256,(void *)NBG1_CEL_ADR);
  slClearBitMap(0);



  int i,j,xmin,xmax,ymin,ymax;
  xmin =-100;
  xmax = 20;
  ymin = -100;
  ymax = 20;


  int col1 = minmaxrndint(0,255);
  int col2 = minmaxrndint(0,255);
  int col3 = minmaxrndint(0,255);



  for (i=xmin;i<xmax;i++){
    for (j=ymin;j<ymax;j++){
      col1 = PAL_WATER+minmaxrndint(0,PAL_WATER_S-1);
      col2 = PAL_FUMEE+minmaxrndint(0,PAL_FUMEE-S-1);
      col3 = PAL_SAND+minmaxrndint(0,PAL_SAND_S-1);
      bm_pixel_set_scroll(bmNBG0,i,j,col1);
      bm_pixel_set_scroll(bmNBG1,i+50,j+50,col2);
      bm_pixel_set_scroll(bmRBG0,i+10,j+100,col3);
    }
  }
  int cr1,cr2,cr3;
  cr1 = cr2 = cr3 = 10;

  slScrAutoDisp(NBG0ON|NBG1ON|RBG0ON);

  int n0,n1,r0;

  n0=n1=r0=1;
  int rate = 0;
  int add = 0;
  int top = 0;
  int deux = 0;
  int ext = 0;


  for (;;){
    if (pad_someone_presses(PER_DGT_ST,1)){
      rate = !rate;
    }
    if (pad_someone_presses(PER_DGT_TA,1)){
      add = !add;      
    }
    if (pad_someone_presses(PER_DGT_TB,1)){
      top = !top;
    }
    if (pad_someone_presses(PER_DGT_TC,1)){
      deux = !deux;
    }
    if (pad_someone_presses(PER_DGT_KU,1)){
      ext = !ext;
    }

    if (pad_someone_presses(PER_DGT_KL,1)){
      n0 = !n0;
    }
    if (pad_someone_presses(PER_DGT_KD,1)){
      n1 = !n1;
    }
    if (pad_someone_presses(PER_DGT_KR,1)){
      r0 = !r0;
    }

    int oioi = 30;
    int zoie1,zoie2;
    for (zoie1=-120;zoie1<-90;zoie1++){
      for (zoie2=oioi;zoie2<120;zoie2++){
	bm_pixel_set_scroll(bmNBG1,zoie1,zoie2,2);
      }
    }

    text_write(bmNBG1,-150,oioi,(ext?"CC EXT  1":"CC EXT  O"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(rate?"CC RATE 1":"CC RATE O"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(add?"CC ADD 1":"CC ADD O"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(top?"CC TOP 1":"CC TOP O"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(deux?"CC 2ND 1":"CC 2ND O"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(n0?"NBG0 1":"NBG0 0"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(n1?"NBG1 1":"NBG1 0"),1,1);oioi+=10;
    text_write(bmNBG1,-150,oioi,(r0?"RBG0 1":"RBG0 0"),1,1);oioi+=10;


    if (pad_someone_presses(PER_DGT_TX,1)) cr1++;
    if (pad_someone_presses(PER_DGT_TY,1)) cr2++;
    if (pad_someone_presses(PER_DGT_TZ,1)) cr3++;    

    slColorCalc((ext?CC_EXT:0)|
		(rate?CC_RATE:0)|
		(add?CC_ADD:0)|
		(top?CC_TOP:0)|
		(deux?CC_2ND:0)|
		(n0?NBG0ON:0)|
		(n1?NBG1ON:0)|
		(r0?RBG0ON:0));

    //   slColorCalcOn((n0?NBG0ON:0)|(n1?NBG1ON:0)|(r0?RBG0ON:0));

    /*    
	  slColRateNbg0(cr1);
	  slColRateNbg1(cr2);
	  slColRateRbg0(cr3);
    */
    
    slPriorityNbg0(cr1);
    slPriorityNbg1(cr2);
    slPriorityRbg0(cr3);

  
    slSynch();
  }
}    



typedef struct {
  int num;
} VICTORY;


VICTORY Victories[MAX_VICTORY];
int c_vict;

void victories_init(){
  int i;
  for (i=0;i<MAX_VICTORY;i++){
    Victories[i].num = -1;
  }
  c_vict = 0;
}

void victories_register(){
  int i;

  int alive=-1;
  for (i=0;i<PLAYER_NUM;i++){  
    alive = (Players[i].energy>0)?i:-1;
    alive = (Players[i].plays)?alive:-1;
    if (alive != -1)
      break;
  }

  if (alive == -1) {
    Victories[c_vict].num = -1;
  } else {
    Victories[c_vict].num = alive;
  }
  c_vict++;
}

void victories_display(GAME* g,int turn){
  int to = 70;
  slScrAutoDisp(NBG0ON|NBG1ON);
  slClearBitMap(0);
  int y = -Y_MAX/2+10;
  int txtpos = text_write(bmNBG1,-160,y,"ROUND",2,PAL_PLAYER);
  txtpos = text_write_int(bmNBG1,txtpos+10,y,turn,2,PAL_PLAYER+1);
  txtpos = text_write(bmNBG1,txtpos+10,y,"OF",2,PAL_PLAYER+2);
  txtpos = text_write_int(bmNBG1,txtpos+10,y,g->n_round,2,PAL_PLAYER+3);

  if (c_vict>0){
    if (Victories[c_vict-1].num == -1){
      txtpos = text_write(bmNBG1,-100,-80,"DRAW",4,PAL_PLAYER+5);
    } else {
      txtpos = text_write(bmNBG1,-140,-80,"WINNER",6,PAL_FUMEE);
    }
  } 

  // resultats
  do { 
    slPushUnitMatrix();
    {
      int i;
      int vic;

      int line_s = 19;
      int tank_s = 17;
      FIXED xoff = toFIXED(20.0);
      FIXED yoff = toFIXED(140.0);

      for (i=0;i<c_vict;i++){
	vic = Victories[i].num;
	if (vic!=-1){
	  Players[vic].energy = 1;
	  Players[vic].pos[X] = toFIXED(1.0*(i%line_s)*tank_s)-toFIXED(X_MAX/2.0)+xoff;
	  Players[vic].pos[Y] = toFIXED(1.0*(i/line_s)*tank_s)-toFIXED(Y_MAX/2.0)+yoff;
	  player_display(&(Players[vic]),1,0);
	}
      }
      if (vic!=-1){
	Players[vic].pos[X] = toFIXED(-10.0);
	Players[vic].pos[Y] = toFIXED(-40.0);
	Players[vic].dir += DEGtoANG(2.0);
	Players[vic].fire_dir += DEGtoANG(-0.3);
	player_display(&(Players[vic]),4,0);
      }
      int j;
      for (j=0;j<50;j++) clear_one();
    }
    slPopMatrix();
	
    to--;	
    sound_step();
    slSynch();
  }
  while (((to>0)||(!pad_someone_presses(PER_DGT_ST,0)))&&(to>-2000));
}


void final_victories_display(){
  int i;  
  
  bm_rect_f(bmNBG0,-X_MAX/2,-Y_MAX/2,X_MAX,Y_MAX,0);
  bm_rect_f(bmNBG1,-X_MAX/2,-Y_MAX/2,X_MAX,Y_MAX,0);

  text_write(bmNBG0,-X_MAX/2+50,-Y_MAX/2+10,"GAME OVER",4,PAL_FUMEE);

  int scores[PLAYER_NUM];
  int best=0;

  for (i=0;i<PLAYER_NUM;i++){
    scores[i] = 0;
  }

  for (i=0;i<c_vict;i++){
    int vic = Victories[i].num;
    if (vic!=-1) {
      scores[vic] += 1;
      if (scores[vic]>best) best=scores[vic];
    }
  }

  
  int playing_losers=0;
  int playing_winners=0;

  for (i=0;i<PLAYER_NUM;i++){
    playing_losers +=  ((Players[i].plays)&&(scores[i]!=best))?1:0;
    playing_winners += ((Players[i].plays)&&(scores[i]==best))?1:0;
  }

  if (best!=-1){
    int posy = -Y_MAX/2+70;
    if (playing_winners>1){
      text_write(bmNBG0,-X_MAX/2+125,posy,"WINNERS",2,PAL_PLAYER+4);
    }else{
      text_write(bmNBG0,-X_MAX/2+125,posy,"WINNER",2,PAL_PLAYER+4);
    }
    posy+=60;
    int posx = text_write(bmNBG0,-X_MAX/2+125,posy,"WITH",1,PAL_PLAYER+4);
    posx = text_write_int(bmNBG0,posx+2,posy,best,1,PAL_PLAYER+4);
    posx +=3;
    if (best>1){
      text_write(bmNBG0,posx,posy,"POINTS",1,PAL_PLAYER+4);
    } else {
      text_write(bmNBG0,posx,posy,"POINT",1,PAL_PLAYER+4);
    }
  }

  int posy = 50;
  int xwidth = (X_MAX*3/4)/playing_losers;
  int xleft = (-X_MAX*3/4)/2;

  for (i=0;i<PLAYER_NUM;i++){
    if (Players[i].plays){
      if (scores[i]!=best){
	text_write_int(bmNBG0,xleft+xwidth/2,posy,scores[i],2,PAL_PLAYER+i);
	xleft +=xwidth;
      }
    }
  }
  int to = 100;
  int goon = 1;
  do {
    
    
    int wposy  = -Y_MAX/2+105;
    int wxwidth = (X_MAX*1/3)/playing_winners;
    int wxleft  = (-X_MAX*1/3)/2;
    
    for (i=0;i<PLAYER_NUM;i++){
      if (Players[i].plays){
	if (scores[i]==best){
	  Players[i].energy = 1;
	  Players[i].pos[X] =  toFIXED(1.0*wxleft+wxwidth/2);
	  Players[i].pos[Y] = toFIXED(1.0*wposy);
	  player_display(&(Players[i]),2.8,0);	  
	  wxleft +=wxwidth;
	}
      }
    }
    

    slSynch();
    to--;
    goon = (to>0);
    if (!goon) {
      goon = !pad_someone_presses(PER_DGT_ST,1);
    }
  }  while (goon);
  slSynch();
}

void ss_main() {


  BANDELETTES bandelettes;
  GAME game;

  int i;

  //  test_table();
  trigolo_init();
  init_traj_sin_table();
  init_BackUp();

  persist_load(&bandelettes);
  bandelettes.n_on +=1;
  for (i=0;i<bandelettes.n_on;i++){
    slRandom();
  }
  persist_save(&bandelettes);

  gfx_init();   
  sound_init();

  // PRESENTATION
  int help = present(&bandelettes);
  if (help){
    instructions_write();

  }

  while (1){

    // GAME SELECTION
    players_init();
    victories_init();

    game_selection(&game,&bandelettes);
    bandelettes.game_n_round = game.n_round;
    bandelettes.game_add_cipius = game.add_cipius;
    persist_save(&bandelettes);
    
    // GAME
    int turn = 0;
    
    while (turn<game.n_round) {
      turn++;
      
      // inits 
      gfx_init();   
      sound_init();
      terrain_init();
      players_init();
      bombs_init();
      bonuss_init();
      mitrail_init();
      
      for (i=0;i<PLAYER_NUM;i++){
	if (game.pad[i] != -1){
	  Players[i].pad = game.pad[i];
	  Players[i].is_cipiu = 0;
	  Players[i].plays = 1;
	} else {
	  if (game.add_cipius) {
	    Players[i].plays = 1;
	  } else {
	    Players[i].plays = 0;
	  }
	  Players[i].is_cipiu = 1;
	}
      }

      /*      for (i=2;i<PLAYER_NUM;i++){
	Players[i].plays=0;
      }
      */
      slSynch();
      int go_timeout = 240;
      
      // tes_sound_multi();
      
      // jeu
      //    printtranspal();
      int landing_to = 60;
      
      sound_tell(vs_b_eau,3);
      do {
	
	slPushUnitMatrix();
	{
	  if (landing_to>0){
	    landing_to--;
	    
	    for (i=0;i<PLAYER_NUM;i++) {
	      if (Players[i].plays){
		player_display(&(Players[i]),landing_to/2+2,0);
	      }
	    }
	    
	    if (landing_to==1) sound_tell(vs_b_terre,1);
	    
	  } else {

	    players_set_next();
	    players_check();
	    players_display();
	    
	    
	    bombs_step();
	    bombs_display();
	    bombs_check_players();
	    
	    bonuss_step();
	    bonuss_display();
	    bonuss_check_players();
	    
	    mitrail_step();
	    mitrail_display();
	    mitrail_check_players();
	    
	    players_display_energy();
	    players_display_ammo();
	  }
	  for (i=0;i<20;i++) clear_one();
	}
	slPopMatrix();
	
	if (check_game_over()) go_timeout--;
	
	sound_step();
	slSynch();
      } while (go_timeout!=0);
      
      // fin du jeu
      sound_tell(vs_b_eau,2);
      victories_register();
      victories_display(&game,turn);
  
    }
    final_victories_display();
  }
}




