#include "mitrail.h"
#include "player.h"
#include "random.h"
#include "bitmap.h"
#include "coll.h"
#include "sound.h"
#include "trigolo.h"


extern PLAYER Players[];
extern SPR_ATTR attr[];

MITRAIL Mitrail[MAX_MITRAIL];

void mitrail_init(){
  int i;
  for (i=0;i<MAX_MITRAIL;i++){
    Mitrail[i].used = 0;
    Mitrail[i].pos[X] = toFIXED(10.0);
    Mitrail[i].pos[Y] = toFIXED(10.0);
  }
}

void mitrail_fire(FIXED pos[XY],ANGLE dir){
  int i;
  int dispo = -1;
  for (i=0;i<MAX_MITRAIL;i++){
    if (!(Mitrail[i].used)) dispo = i;
    if (dispo!=-1) break;
  }
  if (dispo!=-1){
    sound_tell(vs_m_tire,3);
    Mitrail[dispo].used = 1;
    Mitrail[dispo].pos[X]= pos[X];
    Mitrail[dispo].pos[Y]= pos[Y];
    Mitrail[dispo].dir = dir;

    FIXED coscos = cosinus(Mitrail[i].dir);    
    FIXED sinsin = sinus(Mitrail[i].dir);
    

    Mitrail[i].pos[X] +=  slMulFX(toFIXED(15.0),coscos);
    Mitrail[i].pos[Y] +=  slMulFX(toFIXED(15.0),sinsin);
    Mitrail[dispo].age = 0;
  }
}

void mitrail_step(){
  int i;
  for (i=0;i<MAX_MITRAIL;i++){
    if (Mitrail[i].used){
      Mitrail[i].age +=1;
      if (Mitrail[i].age>MAX_AGE){
	Mitrail[i].used = 0;
      } else {
	Mitrail[i].pos[X] +=  slMulFX(toFIXED(4.0),cosinus(Mitrail[i].dir));
	Mitrail[i].pos[Y] +=  slMulFX(toFIXED(4.0),sinus(Mitrail[i].dir));
      }
    }
  }
}

void mitrail_display(){
  int i;
  for (i=0;i<MAX_MITRAIL;i++){
    if (Mitrail[i].used){
      static FIXED post[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(0.15)};
      post[X] = Mitrail[i].pos[X];
      post[Y] = Mitrail[i].pos[Y];
      slDispSprite(post, (SPR_ATTR *)(&attr[25].texno), 0x0);   
    }
  }
}
void mitrail_display_impact(int posx,int posy,int pcol){

  int i;
  int x = posx;
  int y = posy;
  int col = pcol;

  bm_pixel_set2(x,y,col);

  for (i=0;i<2;i++){
    x = posx - 1 + minmaxrndint(0,2);
    y = posy - 1 + minmaxrndint(0,2);
    col =  PAL_FUMEE+(PAL_FUMEE_S-1)/2 + minmaxrndint(0,(PAL_FUMEE_S-1)/2);
    bm_pixel_set2(x,y,col);
  }
}
void mitrail_check_players(){
  int i,j;
  for (i=0;i<MAX_MITRAIL;i++){
    if (Mitrail[i].used){
      int col = 0;
      for (j=0;j<PLAYER_NUM;j++){
	if (Players[j].plays){
	  FIXED l[XY];
	  l[X]=toFIXED(TANK_SIZE*1.0);
	  l[Y]=toFIXED(TANK_SIZE*0.7);
	  col = point_rect_collide(Mitrail[i].pos,Players[j].pos,Players[j].dir,l);
	  if (col){
	    Players[j].energy-=10;
	    mitrail_display_impact(Mitrail[i].pos[X]>>16,Mitrail[i].pos[Y]>>16,PAL_PLAYER+j);
	    sound_tell(vs_m_tank,3);
	  }
	  if (col) break;
	}
      }
      if (col) Mitrail[i].used=0;
    }
  }
}
